use strict;
use Getopt::Std;

my %options=();
getopts("ebl:t:c:h", \%options);

my $track = "A";
my $lang = "en";

if (defined $options{h} || !%options)
{
    my $help = "Options:\n";
    $help = $help."\t-b: Use baseline system.\n";
    $help = $help."\t-e: Apply event coreference.\n";
    $help = $help."\t-l language: Apply for English[en], Spanish[es] or CrossLingually[cross] [default: en].\n";
    $help = $help."\t-t track: Apply for track [A|B] [default: A].\n";
    $help = $help."\t-c file: The config used for execution.\n";
    $help = $help."\t-h: This menu.\n";
    die $help;
}

die "Not valid track.\n" if (defined $options{t} && $options{t} ne "A" && $options{t} ne "B");
$track = $options{t};
die "Not valid language.\n" if (defined $options{l} && $options{l} ne "en" && $options{l} ne "es" && $options{l} ne "cross");
$lang = $options{l};
die "Conf file not found.\n" if (not -e $options{c});
my $confile = $options{c};

open(CONF,$confile);
my $process=0;
my $corpid="";
while(my $line=<CONF>)
{
    chop $line;
    if ($line=~/^\#/)
    {
	($corpid,$process) = split(/ /,$line);
    }
    elsif ($line ne "" && not($line=~/^\#/) && $process)
    {
	my ($target,$corpus,$outdir,$catdir) = split(/ /,$line);
	my  $mappings = "entity-mappings/".$lang;
	my $outfile = lc($target).".txt";
	$outfile=~s/\&/_and_/;	

	print "\t".$corpid." ".$target."\n";
	if (defined $options{b})
	{
	    if (defined $options{e})
	    {
		system ("perl extractTimeLinesEvCoref.pl $corpus $target $mappings $track $catdir bte > $outdir/$outfile")
	    }
	    else
	    {
		system ("perl extractTimeLines.pl $corpus $target $mappings $track $catdir bte > $outdir/$outfile")
	    }
	}
	else
	{
	    if (defined $options{e})
	    {
		system ("perl extractTimeLinesEvCoref.pl $corpus $target $mappings $track $catdir dlt > $outdir/$outfile")
	    }
	    else
	    {
		system ("perl extractTimeLines.pl $corpus $target $mappings $track $catdir dlt > $outdir/$outfile")
	    }
	}
    }
}
close(CONF);
